package {	

	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.text.TextField;
	import flash.utils.Timer;
	import flash.media.Sound;

	public class Clock extends Sprite {
		
		public static const TIME_UP:String = "timeup";
		
		public var t_min:TextField;
		public var t_tens:TextField;
		public var t_ones:TextField;
		public var t_colon:TextField;
		
		private var _timer:Timer;
		private var _seconds:int;
		private var _fields:Array; 
		private var _warnSound:Sound = new WarnSound();
		
		// CONSTRUCTOR
		public function Clock() {
			super();
			_fields = [t_min, t_colon, t_tens, t_ones];
			_timer = new Timer(1000);
			_timer.addEventListener(TimerEvent.TIMER, onTimerTick);
		}
		
		//-----------------------------------------------------------------------------
		public function setTime(secs:int):void {
			_seconds = secs;
			updateDisplay(_seconds);
			colorFields(0x999999);
		}
		
		//-----------------------------------------------------------------------------
		public function start():void {
			_timer.start();
		}
		
		//-----------------------------------------------------------------------------
		public function stop():void {
			_timer.stop();
		}
		
		// ---------------------------------------------------------------
		// ::: PRIVATE ::: 
		// ---------------------------------------------------------------
		
		//-----------------------------------------------------------------------------
		protected function onTimerTick(e:TimerEvent):void {
			_seconds --;
			updateDisplay(_seconds);
			
			if(_seconds <= 0){
				stop();
				dispatchEvent(new Event(TIME_UP));
			} else if(_seconds <= 10){
				_warnSound.play();
				colorFields(0xFF002B);
			}
			
		}
		
		//-----------------------------------------------------------------------------
		protected function colorFields(color:uint):void {
			for each(var tf:TextField in _fields){
				tf.textColor = color;
			}
		}
		
		//-----------------------------------------------------------------------------
		protected function updateDisplay(secs:int):void {
			var min:int = Math.floor(secs / 60);
			secs -= min * 60;
			
			var tens:int = Math.floor(secs / 10);
			secs -= tens * 10;
			
			t_min.text = String(min);
			t_tens.text = String(tens);
			t_ones.text = String(secs);
			
		}
	}

}